#include <stdio.h>
#include <ctype.h>

void lib_write_int(int n)
{
    printf("%d",n);
}
void lib_write_char(char c)
{
    switch (c)
    {
    case '\t':
    case '\n':
	putchar(c);
	break;
    default:
        if (iscntrl(c))
	    printf("\\x%02x",((unsigned)c) & 255);
        else
            putchar(c);
	break;
    }
}
void lib_write_str(char* str)
{
    while (*str)
        lib_write_char(*(str++));
}
void lib_read_int(int* n)
{
    scanf("%d",n);
    fflush(stdin);
}
void lib_read_char(char* c)
{
    *c = getchar();
}
void lib_read_str(char* str)
{
    int len;
    fgets(str,256,stdin);
    fflush(stdin);
    len = strlen(str);
    if (len>0)
    {
	if (str[len-1]=='\n') str[len-1]=0;
    }
}

int lib_eof()
{
    return feof(stdin)?1:0;
}

int lib_int_to_char(int n)
{
    if ((n<0)||(n>255))
    {
	printf("runtime error: char value %d is out of range (%d..%d)\n", 
	       n, 0, 255);
	exit(1);
    }
    return n;
}

void lib_range_check(int t1, int t2, int t3)
{
    if ((t1<t2)||(t1>t3))
    {
	printf("runtime error: subrange value %d is out of range (%d..%d)\n",
	       t1, t2, t3);
	exit(1);
    }
}

void lib_index_check(int t1,int t2,int t3)
{
    if ((t1<t2)||(t1>t3))
    {
	printf("runtime error: index value %d is out of range (%d..%d)\n",
	       t1, t2, t3);
	exit(1);
    }
}

void lib_divide_by_zero()
{
    printf("runtime error: divide by zero\n");
    exit(1);
}
